<?php
 
 
 

namespace PhpWA\Protocol\Proto\StatusAttribution\StatusReshare;

use UnexpectedValueException;




class Source
{
    


    const UNKNOWN = 0;
    


    const INTERNAL_RESHARE = 1;
    


    const MENTION_RESHARE = 2;
    


    const CHANNEL_RESHARE = 3;
    


    const FORWARD = 4;

    private static $valueToName = [
        self::UNKNOWN => 'UNKNOWN',
        self::INTERNAL_RESHARE => 'INTERNAL_RESHARE',
        self::MENTION_RESHARE => 'MENTION_RESHARE',
        self::CHANNEL_RESHARE => 'CHANNEL_RESHARE',
        self::FORWARD => 'FORWARD',
    ];

    public static function name($value)
    {
        if (!isset(self::$valueToName[$value])) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no name defined for value %s', __CLASS__, $value));
        }
        return self::$valueToName[$value];
    }


    public static function value($name)
    {
        $const = __CLASS__ . '::' . strtoupper($name);
        if (!defined($const)) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no value defined for name %s', __CLASS__, $name));
        }
        return constant($const);
    }
}

